--  title: Q-VDU Screen Output
--     by: Matt Sephton, Tektonix Software
-- e-mail: u5ms@csc.liv.ac.uk
--    www: http://www.csc.liv.ac.uk/~u5ms/
--  notes: See TESTQVDU.EX for example usage and Q-VDU.TXT for instructions.
-- FUTURE: Better string handling, ie. those longer than screen width.

include graphics.e

sequence vc

global procedure vdu_init(integer COLOUR, atom GRAPHICS_MODE)
    if graphics_mode(GRAPHICS_MODE) then
       puts(1, "\nQ-VDU: Unable to set graphics mode!\n")
       abort(1)
    end if
    vc = video_config()

    text_color(COLOUR)
    cursor(NO_CURSOR)
end procedure

global procedure vdu_quit()
    -- revert to old graphics mode
    if graphics_mode(-1) then
    end if
end procedure

global procedure vdu_pat(integer X, integer Y, sequence TEXT)
    sequence loc
    atom t, l

    l = length(TEXT)

    if l >= vc[VC_COLUMNS] then     -- string too long
       vdu_quit()                   -- max. length = vc[VC_COLUMNS] - 1
    end if

    loc = get_position()
    if loc[1] < Y then
       for i = loc[1] + 1 to Y do
	   position(i, 1)
	   puts(1, "")
	   t = time()
	   while t + 0.02 > time() do
	   end while
	   position(i, 1)
	   puts(1, " ")
       end for
    end if

    position(Y, X)
    for i = 1 to length(TEXT) do
	position(Y, i)
	puts(1, TEXT[i] & 219)
	t = time()
	while t + 0.02 > time() do
	end while
	position(Y, i + 1)
	puts(1, " ")
    end for
end procedure

global procedure vdu_wait(atom DELAY)
   sequence loc, t

   loc = get_position()
   if loc[2] = 1 then
      loc[2] = loc[2] + 1
   end if
   position(loc[1], loc[2])

   t = {0, 0}
   t[1] = time()
   while t[1] + DELAY > time() do
       t[2] = time()
       while t[2] + 0.1 > time() do
       end while
       position(loc[1], loc[2] - 1)
       puts(1, 219)

       t[2] = time()
       while t[2] + 0.1 > time() do
       end while
       position(loc[1], loc[2] - 1)
       puts(1, " ")
   end while
end procedure

global procedure vdu_cls()
    clear_screen()
    vdu_wait(1)
end procedure
